| OpenCV 5.0.0alpha Open Source Computer Vision

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | List of all members
cv::xfeatures2d::DAISY Class Referenceabstract
Extra 2D Features Framework » Experimental 2D Features Algorithms

Class implementing DAISY descriptor, described in [271]. More...

`#include <opencv2/xfeatures2d.hpp>`

Collaboration diagram for cv::xfeatures2d::DAISY:

## Public Types
enum | NormalizationType { NRM_NONE = 100 , NRM_PARTIAL = 101 , NRM_FULL = 102 , NRM_SIFT = 103 }

## Public Member Functions
virtual void | compute (InputArray image, OutputArray descriptors)=0
virtual void | compute (InputArray image, Rect roi, OutputArray descriptors)=0
virtual void | compute (InputArray image, std::vector< KeyPoint > &keypoints, OutputArray descriptors) CV_OVERRIDE=0
virtual void | compute (InputArrayOfArrays images, std::vector< std::vector< KeyPoint > > &keypoints, OutputArrayOfArrays descriptors) CV_OVERRIDE
String | getDefaultName () const CV_OVERRIDE
virtual void | GetDescriptor (double y, double x, int orientation, float *descriptor) const =0
virtual bool | GetDescriptor (double y, double x, int orientation, float *descriptor, double *H) const =0
virtual cv::Mat | getH () const =0
virtual bool | getInterpolation () const =0
virtual int | getNorm () const =0
virtual int | getQHist () const =0
virtual int | getQRadius () const =0
virtual int | getQTheta () const =0
virtual float | getRadius () const =0
virtual void | GetUnnormalizedDescriptor (double y, double x, int orientation, float *descriptor) const =0
virtual bool | GetUnnormalizedDescriptor (double y, double x, int orientation, float *descriptor, double *H) const =0
virtual bool | getUseOrientation () const =0
virtual void | setH (InputArray H)=0
virtual void | setInterpolation (bool interpolation)=0
virtual void | setNorm (int norm)=0
virtual void | setQHist (int q_hist)=0
virtual void | setQRadius (int q_radius)=0
virtual void | setQTheta (int q_theta)=0
virtual void | setRadius (float radius)=0
virtual void | setUseOrientation (bool use_orientation)=0
Public Member Functions inherited from cv::Feature2D
virtual | ~Feature2D ()
virtual int | defaultNorm () const
virtual int | descriptorSize () const
virtual int | descriptorType () const
virtual void | detect (InputArray image, std::vector< KeyPoint > &keypoints, InputArray mask=noArray())
| Detects keypoints in an image (first variant) or image set (second variant).
virtual void | detect (InputArrayOfArrays images, std::vector< std::vector< KeyPoint > > &keypoints, InputArrayOfArrays masks=noArray())
virtual void | detectAndCompute (InputArray image, InputArray mask, std::vector< KeyPoint > &keypoints, OutputArray descriptors, bool useProvidedKeypoints=false)
virtual bool | empty () const CV_OVERRIDE
| Return true if detector object is empty.
virtual void | read (const FileNode &) CV_OVERRIDE
| Reads algorithm parameters from a file storage.
void | read (const String &fileName)
void | write (const String &fileName) const
virtual void | write (FileStorage &) const CV_OVERRIDE
| Stores algorithm parameters in a file storage.
void | write (FileStorage &fs, const String &name) const
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state.
virtual void | save (const String &filename) const
void | write (FileStorage &fs, const String &name) const

## Static Public Member Functions
static Ptr< DAISY > | create (float radius=15, int q_radius=3, int q_theta=8, int q_hist=8, DAISY::NormalizationType norm=DAISY::NRM_NONE, InputArray H=noArray(), bool interpolation=true, bool use_orientation=false)
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file.
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String.
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node.

## Additional Inherited Members
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

Class implementing DAISY descriptor, described in [271].

Parameters

  radius | radius of the descriptor at the initial scale
  q_radius | amount of radial range division quantity
  q_theta | amount of angular range division quantity
  q_hist | amount of gradient orientations range division quantity
  norm | choose descriptors normalization type, where DAISY::NRM_NONE will not do any normalization (default), DAISY::NRM_PARTIAL mean that histograms are normalized independently for L2 norm equal to 1.0, DAISY::NRM_FULL mean that descriptors are normalized for L2 norm equal to 1.0, DAISY::NRM_SIFT mean that descriptors are normalized for L2 norm equal to 1.0 but no individual one is bigger than 0.154 as in SIFT
  H | optional 3x3 homography matrix used to warp the grid of daisy but sampling keypoints remains unwarped on image
  interpolation | switch to disable interpolation for speed improvement at minor quality loss
  use_orientation | sample patterns using keypoints orientation, disabled by default.

## Member Enumeration Documentation

## ◆ NormalizationType

enum cv::xfeatures2d::DAISY::NormalizationType

Enumerator
NRM_NONE |
NRM_PARTIAL |
NRM_FULL |
NRM_SIFT |

## Member Function Documentation

## ◆ compute() [1/4]

virtual void cv::xfeatures2d::DAISY::compute | ( | InputArray | image,
|  | OutputArray | descriptors )
| pure virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Parameters

  image | image to extract descriptors
  descriptors | resulted descriptors array for all image pixels

## ◆ compute() [2/4]

virtual void cv::xfeatures2d::DAISY::compute | ( | InputArray | image,
|  | Rect | roi,
|  | OutputArray | descriptors )
| pure virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Parameters

  image | image to extract descriptors
  roi | region of interest within image
  descriptors | resulted descriptors array for roi image pixels

## ◆ compute() [3/4]

virtual void cv::xfeatures2d::DAISY::compute | ( | InputArray | image,
|  | std::vector< KeyPoint > & | keypoints,
|  | OutputArray | descriptors )
| pure virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Parameters

  image | image to extract descriptors
  keypoints | of interest within image
  descriptors | resulted descriptors array

Reimplemented from cv::Feature2D.

## ◆ compute() [4/4]

virtual void cv::xfeatures2d::DAISY::compute | ( | InputArrayOfArrays | images,
|  | std::vector< std::vector< KeyPoint > > & | keypoints,
|  | OutputArrayOfArrays | descriptors )
| virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Parameters

  images | Image set.
  keypoints | Input collection of keypoints. Keypoints for which a descriptor cannot be computed are removed. Sometimes new keypoints can be added, for example: SIFT duplicates keypoint with several dominant orientations (for each orientation).
  descriptors | Computed descriptors. In the second variant of the method descriptors[i] are descriptors computed for a keypoints[i]. Row j is the keypoints (or keypoints[i]) is the descriptor for keypoint j-th keypoint.

Reimplemented from cv::Feature2D.

## ◆ create()

static Ptr< DAISY > cv::xfeatures2d::DAISY::create | ( | float | radius = 15,
|  | int | q_radius = 3,
|  | int | q_theta = 8,
|  | int | q_hist = 8,
|  | DAISY::NormalizationType | norm = DAISY::NRM_NONE,
|  | InputArray | H = noArray(),
|  | bool | interpolation = true,
|  | bool | use_orientation = false )
| static

Python:
| cv.xfeatures2d.DAISY.create( | [, radius[, q_radius[, q_theta[, q_hist[, norm[, H[, interpolation[, use_orientation]]]]]]]] | ) -> | retval
| cv.xfeatures2d.DAISY_create( | [, radius[, q_radius[, q_theta[, q_hist[, norm[, H[, interpolation[, use_orientation]]]]]]]] | ) -> | retval

Here is the call graph for this function:

## ◆ getDefaultName()

String cv::xfeatures2d::DAISY::getDefaultName | ( |  | ) | const
| virtual

Python:
| cv.xfeatures2d.DAISY.getDefaultName( |  | ) -> | retval

Returns the algorithm string identifier. This string is used as top level xml/yml node tag when the object is saved to a file or string.

Reimplemented from cv::Feature2D.

## ◆ GetDescriptor() [1/2]

virtual void cv::xfeatures2d::DAISY::GetDescriptor | ( | double | y,
|  | double | x,
|  | int | orientation,
|  | float * | descriptor ) const
| pure virtual

Parameters

  y | position y on image
  x | position x on image
  orientation | orientation on image (0->360)
  descriptor | supplied array for descriptor storage

## ◆ GetDescriptor() [2/2]

virtual bool cv::xfeatures2d::DAISY::GetDescriptor | ( | double | y,
|  | double | x,
|  | int | orientation,
|  | float * | descriptor,
|  | double * | H ) const
| pure virtual

Parameters

  y | position y on image
  x | position x on image
  orientation | orientation on image (0->360)
  descriptor | supplied array for descriptor storage
  H | homography matrix for warped grid

## ◆ getH()

virtual cv::Mat cv::xfeatures2d::DAISY::getH | ( |  | ) | const
| pure virtual

Python:
| cv.xfeatures2d.DAISY.getH( |  | ) -> | retval

## ◆ getInterpolation()

virtual bool cv::xfeatures2d::DAISY::getInterpolation | ( |  | ) | const
| pure virtual

Python:
| cv.xfeatures2d.DAISY.getInterpolation( |  | ) -> | retval

## ◆ getNorm()

virtual int cv::xfeatures2d::DAISY::getNorm | ( |  | ) | const
| pure virtual

Python:
| cv.xfeatures2d.DAISY.getNorm( |  | ) -> | retval

## ◆ getQHist()

virtual int cv::xfeatures2d::DAISY::getQHist | ( |  | ) | const
| pure virtual

Python:
| cv.xfeatures2d.DAISY.getQHist( |  | ) -> | retval

## ◆ getQRadius()

virtual int cv::xfeatures2d::DAISY::getQRadius | ( |  | ) | const
| pure virtual

Python:
| cv.xfeatures2d.DAISY.getQRadius( |  | ) -> | retval

## ◆ getQTheta()

virtual int cv::xfeatures2d::DAISY::getQTheta | ( |  | ) | const
| pure virtual

Python:
| cv.xfeatures2d.DAISY.getQTheta( |  | ) -> | retval

## ◆ getRadius()

virtual float cv::xfeatures2d::DAISY::getRadius | ( |  | ) | const
| pure virtual

Python:
| cv.xfeatures2d.DAISY.getRadius( |  | ) -> | retval

## ◆ GetUnnormalizedDescriptor() [1/2]

virtual void cv::xfeatures2d::DAISY::GetUnnormalizedDescriptor | ( | double | y,
|  | double | x,
|  | int | orientation,
|  | float * | descriptor ) const
| pure virtual

Parameters

  y | position y on image
  x | position x on image
  orientation | orientation on image (0->360)
  descriptor | supplied array for descriptor storage

## ◆ GetUnnormalizedDescriptor() [2/2]

virtual bool cv::xfeatures2d::DAISY::GetUnnormalizedDescriptor | ( | double | y,
|  | double | x,
|  | int | orientation,
|  | float * | descriptor,
|  | double * | H ) const
| pure virtual

Parameters

  y | position y on image
  x | position x on image
  orientation | orientation on image (0->360)
  descriptor | supplied array for descriptor storage
  H | homography matrix for warped grid

## ◆ getUseOrientation()

virtual bool cv::xfeatures2d::DAISY::getUseOrientation | ( |  | ) | const
| pure virtual

Python:
| cv.xfeatures2d.DAISY.getUseOrientation( |  | ) -> | retval

## ◆ setH()

virtual void cv::xfeatures2d::DAISY::setH | ( | InputArray | H | ) |
| pure virtual

Python:
| cv.xfeatures2d.DAISY.setH( | H | ) -> | None

## ◆ setInterpolation()

virtual void cv::xfeatures2d::DAISY::setInterpolation | ( | bool | interpolation | ) |
| pure virtual

Python:
| cv.xfeatures2d.DAISY.setInterpolation( | interpolation | ) -> | None

## ◆ setNorm()

virtual void cv::xfeatures2d::DAISY::setNorm | ( | int | norm | ) |
| pure virtual

Python:
| cv.xfeatures2d.DAISY.setNorm( | norm | ) -> | None

## ◆ setQHist()

virtual void cv::xfeatures2d::DAISY::setQHist | ( | int | q_hist | ) |
| pure virtual

Python:
| cv.xfeatures2d.DAISY.setQHist( | q_hist | ) -> | None

## ◆ setQRadius()

virtual void cv::xfeatures2d::DAISY::setQRadius | ( | int | q_radius | ) |
| pure virtual

Python:
| cv.xfeatures2d.DAISY.setQRadius( | q_radius | ) -> | None

## ◆ setQTheta()

virtual void cv::xfeatures2d::DAISY::setQTheta | ( | int | q_theta | ) |
| pure virtual

Python:
| cv.xfeatures2d.DAISY.setQTheta( | q_theta | ) -> | None

## ◆ setRadius()

virtual void cv::xfeatures2d::DAISY::setRadius | ( | float | radius | ) |
| pure virtual

Python:
| cv.xfeatures2d.DAISY.setRadius( | radius | ) -> | None

## ◆ setUseOrientation()

virtual void cv::xfeatures2d::DAISY::setUseOrientation | ( | bool | use_orientation | ) |
| pure virtual

Python:
| cv.xfeatures2d.DAISY.setUseOrientation( | use_orientation | ) -> | None

The documentation for this class was generated from the following file:

- opencv2/xfeatures2d.hpp